<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="流动介质" prop="emsCls">
        <treeselect v-model="queryParams.emsCls" :options="emsClsOptions" :show-count="true" placeholder="请选择流动介质"  :style="{ width: '200px' }"/>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['basecfg:flowrel:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['basecfg:flowrel:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['basecfg:flowrel:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="relList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="输出对象" align="center" prop="exportObjName">
        <template slot-scope="scope">
          <span>{{ '(' + getObjType(scope.row.exportObjType) + ') ' +scope.row.exportObjName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="流入对象" align="center" prop="inputObjName">
        <template slot-scope="scope">
          <span>{{ '(' + getObjType(scope.row.inputObjType) + ') ' +scope.row.inputObjName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="流动介质" align="center" prop="emsClsName" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text"  icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['basecfg:flowrel:edit']">
            修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" class="deleteBtn" @click="handleDelete(scope.row)" v-hasPermi="['basecfg:flowrel:remove']">
            删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改能源设施能流关系对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="mergeForm" :model="mergeForm" :rules="rules" label-width="80px">
        <el-form-item label="输出类别" prop="exportObjType">
          <el-select v-model="mergeForm.exportObjType" @change="setCodePrefix" style="width:100%">
            <el-option v-for="item in objOptions" :label="item.name" :value="item.code" :key="item.code" />
          </el-select>
        </el-form-item>
        <el-form-item label="输出对象" prop="exportObj">
          <el-input v-model="mergeForm.exportObj"  placeholder="输出对象" />
        </el-form-item>
        <el-form-item label="流入类别" prop="inputObjType">
          <el-select v-model="mergeForm.inputObjType" @change="setCodeCompose" style="width:100%">
            <el-option v-for="item in objOptions" :label="item.name" :value="item.code" :key="item.code" />
          </el-select>
        </el-form-item>
        <el-form-item label="流入对象" prop="inputObj">
          <el-input v-model="mergeForm.inputObj"  placeholder="流入对象" />
        </el-form-item>
        <el-form-item label="流动介质" prop="emsCls">
          <treeselect v-model="mergeForm.emsCls" :options="emsClsOptions" :show-count="true" placeholder="请选择" />
        </el-form-item>
        <el-form-item label="能流描述" prop="flowDesc">
          <el-input v-model="mergeForm.flowDesc"  placeholder="能流描述" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listRel, getRel, delRel, addRel, updateRel } from "@/api/basecfg/flowrel";
import { listAllFacs } from "@/api/basecfg/emsfacs"
import { getEmsClsTree } from "@/api/commonApi"
import Treeselect from '@riophae/vue-treeselect'
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
export default {
  name: "Rel",
  components: { Treeselect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 能源设施能流关系表格数据
      relList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 区域选项
      areaOptions: undefined,
      // 设施选项
      facsOptions: undefined,
      // 能源分类树
      emsClsOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        exportObjType: null,
        exportObj: null,
        inputObjType: null,
        inputObj: null,
        emsCls: null,
        flowDesc: null,
      },
      queryFacsParams: {
        areaCode: ''
      },
      objOptions: [
        { code: 0, name: "设施"},
        { code: 2, name: "设备"},
        { code: 3, name: "部件"}
      ],
      // 表单参数
      mergeForm: {},
      // 表单校验
      rules: {
        exportObj: [
          { required: true, message: "能源输出对象不能为空", trigger: "blur" }
        ],
        inputObj: [
          { required: true, message: "能源流入对象不能为空", trigger: "blur" }
        ],
        emsCls: [
          { required: true, message: "能源流动介质不能为空", trigger: "blur" }
        ]
      },

    };
  },
  created() {
    this.getList();
    this.getAllFacs();
    this.getEmsCls();
  },
  methods: {
    /** 查询能源设施能流关系列表 */
    getList() {
      this.loading = true;
      listRel(this.queryParams).then(response => {
        this.relList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.mergeForm = {
        id: null,
        code: null,
        exportFacsCode: null,
        inputFacsCode: null,
        emsCls: null,
        state: null,
        actionType: null,
        createTime: null,
        updateTime: null
      };
      this.resetForm("mergeForm");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加能源设施能流关系";
      this.getAllFacs();
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getRel(id).then(response => {
        this.mergeForm = response.data;
        this.open = true;
        this.title = "修改能源设施能流关系";
      });
      this.getAllFacs();
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["mergeForm"].validate(valid => {
        if (valid) {
          if (this.mergeForm.id != null) {
            updateRel(this.mergeForm).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRel(this.mergeForm).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除能源设施能流关系编号为"' + ids + '"的数据项？').then(function() {
        return delRel(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    getObjType(objType) {
      const objTypeMap = {
        1: '设施',
        2: '设备',
        3: '部件'
      };
      return objTypeMap[objType] || '未知';
    },
    getAllFacs() {
      listAllFacs(this.queryFacsParams).then(response =>{
        this.facsOptions = response.data;
      })
    },
    /** 查询能源树结构 */
    getEmsCls() {
      getEmsClsTree().then(response => {
        this.emsClsOptions = response.data;
      });
    },
    setCodePrefix() {
      this.mergeForm.code = this.mergeForm.exportFacsCode;
    },
    setCodeCompose() {
      this.mergeForm.code = this.mergeForm.exportFacsCode + '_' +this.mergeForm.inputFacsCode;
    },
  }
};
</script>
